"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function dispose() {
    var disposables = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        disposables[_i] = arguments[_i];
    }
    var first = disposables[0];
    if (Array.isArray(first)) {
        disposables = first;
    }
    disposables.forEach(function (d) { return d && d.dispose(); });
    return [];
}
exports.dispose = dispose;
var Disposable = (function () {
    function Disposable() {
        this._toDispose = [];
    }
    Disposable.prototype.dispose = function () {
        this._toDispose = dispose(this._toDispose);
    };
    Disposable.prototype._register = function (t) {
        this._toDispose.push(t);
        return t;
    };
    return Disposable;
}());
exports.Disposable = Disposable;
