"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var workingDir = require("../../disk/workingDir");
var fsu = require("../../utils/fsu");
function createEditorconfig(data) {
    var defaultContents = "\n[*.{js,jsx,ts,tsx}]\nindent_style = space\nindent_size = 2\ntrim_trailing_whitespace = true\ninsert_final_newline = true\n\n[*.md]\ntrim_trailing_whitespace = true\ninsert_final_newline = true\n    ".trim();
    var filePath = workingDir.makeAbsolute('./.editorconfig');
    if (fsu.existsSync(filePath)) {
        return Promise.resolve({ alreadyPresent: filePath });
    }
    fsu.writeFile(filePath, defaultContents);
    return Promise.resolve({ alreadyPresent: '' });
}
exports.createEditorconfig = createEditorconfig;
